unit u1K;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, ComCtrls, CheckLst, Mask,
  uAppUtils, z2m;

Const
  WM_POSTINITFORM = WM_USER+1;
  WM_ADDCARD      = WM_USER+2;
  WM_RMVCARD      = WM_USER+3;

type
  TTxtFmtMode = (tfmOem, tfmAnsi);
  T1KSectData = array[0..3, 0..15] of BYTE;
  TCellAttr = (caFrame,
    caManuf,          //   (  )
    caTrailer,
    caData,
    caKey,
    caRead, caWrite,  //  ,    (A  B)
    caInc, caDec
  );
  TCellAttrs = set of TCellAttr;

  Tfm1K = class(TForm)
    panInfo: TPanel;
    labCard: TLabel;
    labStatus: TLabel;
    edtCdTitle: TEdit;
    edtConStat: TEdit;
    panSect: TPanel;
    tvSection: TTreeView;
    grAuthorize: TGroupBox;
    panView: TPanel;
    grDataAcc: TGroupBox;
    imgDataAcc: TImage;
    cbDataAcc: TComboBox;
    grTrailAcc: TGroupBox;
    imgTrailerAcc: TImage;
    cbTrailerAcc: TComboBox;
    panLegend: TPanel;
    grDataLegend: TGroupBox;
    shLegSN: TShape;
    labLegSN: TLabel;
    shLegRWData: TShape;
    labLegRWData: TLabel;
    shLegRData: TShape;
    labLegRData: TLabel;
    shLegFData: TShape;
    labLegFData: TLabel;
    grTrailLegend: TGroupBox;
    shLegRWAccess: TShape;
    labLegRWAccess: TLabel;
    shLegRAccess: TShape;
    labLegRAccess: TLabel;
    shLegWKey: TShape;
    labLegWKey: TLabel;
    shLegLKey: TShape;
    labLegLKey: TLabel;
    shLegRKey: TShape;
    labLegRWKey: TLabel;
    grDataView: TGroupBox;
    pcBlockData: TPageControl;
    tabDirectAccess: TTabSheet;
    gridDataAsHex: TStringGrid;
    TabSheet1: TTabSheet;
    rgTxtFmt: TRadioGroup;
    gridDataAsText: TStringGrid;
    panControl: TPanel;
    btnApply: TButton;
    btnRefresh: TButton;
    pbTransfer: TProgressBar;
    rgAKMode: TRadioGroup;
    pcAuthMode: TPageControl;
    tabAKMask: TTabSheet;
    lbKeyMask: TCheckListBox;
    btnChkAll: TButton;
    btnUnchkAll: TButton;
    btnInputKeys: TButton;
    cbAuthKeyN: TComboBox;
    Label1: TLabel;
    btnSetAK: TButton;
    procedure rgAKModeClick(Sender: TObject);
    procedure cbAuthKeyNChange(Sender: TObject);
    procedure tvSectionExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure tvSectionKeyPress(Sender: TObject; var Key: Char);
    procedure tvSectionDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnInputKeysClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbTrailerAccChange(Sender: TObject);
    procedure cbTrailerAccDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure btnUnchkAllClick(Sender: TObject);
    procedure btnChkAllClick(Sender: TObject);
    procedure cbDataAccChange(Sender: TObject);
    procedure pcBlockDataChange(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure gridDataAsHexSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure gridDataAsTextSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure gridDataAsTextKeyPress(Sender: TObject; var Key: Char);
    procedure rgTxtFmtClick(Sender: TObject);
    procedure gridDataAsTextDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure gridDataAsHexDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure gridDataAsHexKeyPress(Sender: TObject; var Key: Char);
    procedure cbDataAccDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure btnApplyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure PostInitForm(var msg: TMessage); message WM_POSTINITFORM;
    procedure AddCardEvent(var msg: TMessage); message WM_ADDCARD;
    procedure RmvCardEvent(var msg: TMessage); message WM_RMVCARD;

    procedure DoOpenCard();
    procedure DoCloseCard();

    procedure InitDataAccCapt();
    procedure InitTrailerAccCapt();

    procedure UpdatePanInfo();
    procedure UpdatePanSect();
    procedure UpdatePanView();

    procedure UpdateKeyMask();
    procedure UpdateAuthKeyN();
    procedure UpdateDataAcc();
    procedure UpdateTrailAcc();
    procedure UpdateCurDataView();
    procedure UpdateControl();
    procedure UpdateTextFmtMode();

    procedure UpdateTrailer();
    procedure UpdateHexCell(Const ACol, ARow: Integer);
    procedure UpdateTextCell(Const ACol, ARow: Integer);
    procedure UpdateCurSect();

    procedure SetModifyFlag(AModify: Boolean=True);

    function GetKeyMask(): Tz2mAKMask;

    procedure DoneHexCellEdit(ACancel: Boolean=False);
    procedure NextHexCellEdit();

    function GetHexCellTip(Const ACol, ARow: Integer; var AData: T1KSectData): TCellAttrs;
    function GetOldHexCellTip(Const ACol, ARow: Integer): TCellAttrs;
    function GetNewHexCellTip(Const ACol, ARow: Integer): TCellAttrs;

    procedure DoneTextCellEdit(ACancel: Boolean=False);
    procedure NextTextCellEdit();

    procedure DoneCellEdit(ACancel: Boolean=False);
    function GetRdAKFilePath(): String;
    function GetAKComboKeyNToIdx(AKeyN: Integer): Integer;
    function GetAKComboIdxToKeyN(AIdx: Integer): Integer;
    function GetRadioAKModeToIdx(AMode: Tz2mAKMode): Integer;
    function GetRadioAKIdxToMode(AIdx: Integer): Tz2mAKMode;
  public
    { Public declarations }
    FRd             : THandle;
    FCdTip          : Tz2mCardType;
    FCdId           : Tz2mCardNum;

  protected
    m_hCd           : THandle;
    m_hSc           : THandle;
    m_nOldAuthKeyN  : Integer;        //    
                                      //   
    m_nNewAuthKeyN  : Integer;
    m_nRdSN         : Tz2mReaderSn;   // SN 

    m_fAfterDis     : Boolean;

    m_nCurSectN     : Integer;        //    
    m_nLastTVSect   : Integer;        //    
                                      //  TreeView
    //   
    m_nKeyMode1     : Tz2mAKMode;     //    
    m_nKeyMode2     : Tz2mAKMode;     //    
    m_aAreaAcc      : Tz2mMfAccBits;  //    
    m_aOldSectData  : T1KSectData;    //    
    m_aNewSectData  : T1KSectData;    //   
    m_fDataInit     : Boolean;        //  ' '
    m_fKeyInit      : Boolean;        //  ' A  B '
    m_aInitBlock    : array[0..3] of Boolean;//   
    m_fChanged      : Boolean;        //  ' '

    m_nCurDViewN    : Integer;        //   :
                                      // AsHex  AsText
    m_nCurBlockN    : Integer;        //    
    m_fCellEdit     : Boolean;        //    
                                      // TStringGrid
    m_fAsHexUpd     : Boolean;        //  ' '
    m_fAsTextUpd    : Boolean;        //  ' '

    // Data As Hex
    m_nCurHexCol    : Integer;
    m_nCurHexRow    : Integer;
    m_nHexCellSubN  : Integer;
    // Data as Text
    m_nCurTextCol   : Integer;
    m_nCurTextRow   : Integer;
    m_nTextFmtMode  : TTxtFmtMode;
    m_nTextCellSubN : Integer;

    m_fCtrlLock     : Boolean;
  protected
    function SetCurSect(ASectN: Integer; ADViewN: Integer=-1; AUpdate: Boolean=False): Boolean;
    procedure SetCurDView(AViewN: Integer; AUpdate: Boolean=False);
    procedure SetCurBlock(ABlockN: Integer; AUpdate: Boolean=False);
    procedure SetBlockAccess(ABlockN: Integer; AState: Integer);
    procedure SetAuthKeyN(AKeyN: Integer; AUpdate: Boolean=False);
    procedure SetAKMode(AMode: Tz2mAKMode);
    procedure SetTextFmtMode(AMode: TTxtFmtMode; AUpdate: Boolean=False);

    procedure DoRefresh();
    function DoApply(): Boolean;
  end;

Const
  nDataAccCols = 6;
  aDataAccCols: array[0..nDataAccCols-1] of Integer = (30,50,50,80,80,145);
Const
  nTraAccCols = 8;
  aTraAccCols: array[0..nTraAccCols-1] of Integer = (30,50,50,60,60,50,50,85);

var
  fm1K: Tfm1K;

implementation

{$R *.dfm}

uses
  StrUtils, CommCtrl, Math,
  uAppConst, uInpKey;

function GetTVNodeOfIndex(ANodes: TTreeNodes; AIdx: Integer): TTreeNode;
var
  nd, par: TTreeNode;
  nIt: Integer;
begin
  Result := nil;
  nIt := 0;
  nd := ANodes.GetFirstNode;
  par := nd.Parent;
  while nd<>nil do
  begin
    if nIt=AIdx then
    begin
      Result := nd;
      break;
    end;
    Inc(nIt);
    repeat
      nd := nd.GetNext;
    until (nd=nil)or(nd.Parent=par);
  end;
end;

function Tfm1K.SetCurSect(ASectN, ADViewN: Integer; AUpdate: Boolean): Boolean;
var
  nKMode: Tz2mAKMode;
  nKMask: Tz2mAKMask;
  Info: Tz2mMfSectorInfo;
  nRet: Integer;
begin
  assert(m_hCd<>0);
  Result := False;
  if (m_nCurSectN = ASectN) and (m_nCurDViewN=ADViewN) and (not AUpdate) then exit;
  try
    DoneCellEdit();
    if (m_nCurSectN <> ASectN) then
    begin
      if (m_nCurSectN <> -1) then
      begin
        if m_fChanged then
        begin
          case MessageDlg(SMSG_SAVECHANGES, mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
            mrYes: if not DoApply() then exit;
            mrNo:;
            else exit;
          end;
        end;
        z2mCloseMfSector(m_hSc); m_hSc := 0;
      end;
      if ASectN <> -1 then
      begin
        if rgAKMode.ItemIndex = 1 then nKMode := Z2M_K_KeyB else nKMode := Z2M_K_KeyA;
        if pcAuthMode.ActivePageIndex = 0 then
        begin
          nKMask := GetKeyMask();
          if nKMask=0 then
          begin
            MessageDlg(SMSG_AUTHMASKEMPTY, mtError, [mbOk], 0);
            lbKeyMask.SetFocus;
            exit;
          end;
          with Info do
          begin
            hCard := m_hCd;
            nSectN := ASectN;
            fOpenByMask := True;
            nKeyMode := nKMode;
            nKeyMask := nKMask;
          end;
          nRet := z2mOpenMfSector(@m_hSc, @Info);
          if nRet <> Z2M_SUCCESS then m_hSc := 0;

          m_nOldAuthKeyN := Info.nFoundKeyN;
          m_nNewAuthKeyN := m_nOldAuthKeyN;
          if m_hSc = 0 then
          begin
            MsgBoxZ2mErr(Handle, nRet);
            exit;
          end;
        end;
        ASSERT(m_hSc <> 0);
        m_aAreaAcc := Info.aAreaAcc;
        m_nCurSectN  := ASectN;
        m_fChanged  := False;
        m_fDataInit := False;
        m_nKeyMode1 := nKMode;
        m_nKeyMode2 := nKMode;
        m_fKeyInit := False;
      end;
    end;
    Result := True;
  finally
    if m_hSc<>0 then
    begin
      m_nCurSectN := ASectN;
      m_nCurDViewN := ADViewN;
      if m_nCurDViewN=-1 then m_nCurDViewN := 0;
    end
    else
    begin
      m_nCurSectN := -1;
      m_nCurDViewN := -1;
    end;
    SetModifyFlag(False);
    UpdatePanSect();
    UpdatePanView();
    Application.ProcessMessages;
    DoRefresh();
    if m_hSc<>0 then
    begin
      case m_nCurDViewN of
        0:  if gridDataAsHex.CanFocus then gridDataAsHex.SetFocus;
        1:  if gridDataAsText.CanFocus then gridDataAsText.SetFocus;
      end;
    end;
  end;
end;

procedure Tfm1K.SetCurDView(AViewN: Integer; AUpdate: Boolean);
begin
  assert(m_hCd<>0);
  if (m_nCurDViewN = AViewN) and (not AUpdate) then exit;
  DoneCellEdit();
  m_nCurDViewN := AViewN;
  UpdateCurDataView();
end;

procedure Tfm1K.SetCurBlock(ABlockN: Integer; AUpdate: Boolean);
begin
  if (m_nCurBlockN=ABlockN) and (not AUpdate) then exit;
  DoneCellEdit();
  m_nCurBlockN := ABlockN;
  UpdateCurDataView();
  UpdateDataAcc();
end;

procedure Tfm1K.SetBlockAccess(ABlockN: Integer; AState: Integer);
var
  nBits: BYTE;
begin
  nBits := AccessStateToBits(AState);
  z2mEncodeMfAccBits(ABlockN, @m_aNewSectData[3,6], nBits);
  case m_nCurDViewN of
    0:  begin UpdateTrailer(); gridDataAsHex.Invalidate; end;
    1:  begin gridDataAsText.Invalidate; end;
  end;
  if ABlockN=3 then
  begin
    if cbTrailerAcc.ItemIndex <> AState then
      cbTrailerAcc.ItemIndex := AState;
  end
  else
  begin
    if cbDataAcc.ItemIndex <> AState then
      cbDataAcc.ItemIndex := AState;
  end;
  SetModifyFlag();
end;

procedure Tfm1K.SetAuthKeyN(AKeyN: Integer; AUpdate: Boolean);
var
  nKeyA, nKeyB: Tz2mAuthKey;
  j: Integer;
begin
  if (AKeyN=m_nNewAuthKeyN) and (not AUpdate) then exit;
  m_nNewAuthKeyN := AKeyN;
  if ((cbAuthKeyN.ItemIndex=-1) and (m_nNewAuthKeyN<>0)) or
    (GetAKComboIdxToKeyN(cbAuthKeyN.ItemIndex)<>m_nNewAuthKeyN) then
  begin
    cbAuthKeyN.ItemIndex := GetAKComboKeyNToIdx(m_nNewAuthKeyN);
  end;
  if GetAuthKey(m_nRdSN, m_nNewAuthKeyN, nKeyA, nKeyB) then
  begin
    Move(nKeyA, m_aNewSectData[3,0], 6);
    Move(nKeyB, m_aNewSectData[3,10], 6);
    SetModifyFlag();
    for j := 1 to 16 do UpdateHexCell(j, 4);
  end;
end;

procedure Tfm1K.SetAKMode(AMode: Tz2mAKMode);
var
  n: Integer;
begin
  if m_nKeyMode2=AMode then exit;
  DoneCellEdit();
  m_nKeyMode2 := AMode;
  UpdateCurDataView();
  n := GetRadioAKModeToIdx(m_nKeyMode2);
  if n<>rgAKMode.ItemIndex then
    rgAKMode.ItemIndex := n;
  case m_nCurDViewN of
    0:  gridDataAsHex.Invalidate;
    1:  gridDataAsText.Invalidate;
  end;
end;

procedure Tfm1K.SetTextFmtMode(AMode: TTxtFmtMode; AUpdate: Boolean);
var
  i, j: Integer;
begin
  if (AMode = m_nTextFmtMode) and (not AUpdate) then exit;
  DoneTextCellEdit();
  m_nTextFmtMode := AMode;
  UpdateTextFmtMode();
  for i := 1 to 3 do
    for j := 1 to 16 do
      UpdateTextCell(j, i);
  UpdateTextFmtMode();
end;

procedure Tfm1K.DoRefresh();
var
  nBlockN, nRet, nMax: Integer;
  nKeyA, nKeyB: Tz2mAuthKey;
  i: Integer;
  s: string;
begin
  DoneCellEdit();
  if m_hSc=0 then exit;
  pbTransfer.Position := 0;
  pbTransfer.Visible := True;
  btnApply.Enabled := False;
  btnRefresh.Enabled := False;
  try
    for i := 0 to High(m_aInitBlock) do m_aInitBlock[i] := False;
    m_nNewAuthKeyN := m_nOldAuthKeyN;
    m_fDataInit := False;
    m_fKeyInit := False;
    m_fAsHexUpd := False;
    m_fAsTextUpd := False;
    nBlockN := 0;
    while nBlockN < 4 do
    begin
      nRet := z2mReadMfBlock(m_hSc, nBlockN, @m_aOldSectData[nBlockN,0]);
      if nRet = Z2M_SUCCESS then
        m_aInitBlock[nBlockN] := True
      else
      begin
        FillChar(m_aOldSectData[nBlockN,0], 16, 0);
        nMax := 255;
        SetLength(s, nMax);
        z2mGetErrorText(nRet, PChar(s), nMax);
        SetLength(s, nMax);
        if MessageDlg(format(SMSG_READBLOCKERR2, [nBlockN+1, s]),
            mtError, [mbYes, mbNo], 0) <> mrYes then exit;
      end;
      Application.ProcessMessages;
      pbTransfer.StepBy(1);
      Inc(nBlockN);
    end;
    if m_nNewAuthKeyN<>0 then
    begin
      m_fKeyInit := GetAuthKey(m_nRdSN, m_nNewAuthKeyN, nKeyA, nKeyB);
      if m_fKeyInit then
      begin
        Move(nKeyA, m_aOldSectData[3,0], 6);
        Move(nKeyB, m_aOldSectData[3,10], 6);
      end;
    end;
    Move(m_aOldSectData[0,0], m_aNewSectData[0,0], sizeof(m_aNewSectData));
    m_fDataInit := True;
    SetModifyFlag(False);
    btnRefresh.Enabled := True;
  finally
    pbTransfer.Visible := False;
    UpdateAuthKeyN();
    UpdateDataAcc();
    UpdateTrailAcc();
    UpdateCurDataView();
    UpdateControl();
  end;
end;

function Tfm1K.DoApply(): Boolean;
var
  i, nRet, nMax: Integer;
  fAllWrOk: Boolean;
  s: string;
begin
  DoneCellEdit();
  if not m_fChanged then begin Result := True; exit end;
  fAllWrOk := True;
  pbTransfer.Visible := True;
  try
    pbTransfer.Position := 0;
    pbTransfer.Min := 1;
    pbTransfer.Max := 4;
    pbTransfer.Step := 1;
    Result := False;
    for i := 0 to 3 do
    begin
      if m_aInitBlock[i] and
        (not CompareMem(@m_aOldSectData[i,0], @m_aNewSectData[i,0], 16)) then
      begin
        nRet := z2mWriteMfBlock(m_hSc, i, @m_aNewSectData[i,0]);
        if nRet = Z2M_SUCCESS then
        begin
          Move(m_aNewSectData[i,0], m_aOldSectData[i,0], 16);
          if i=3 then
          begin
            m_nOldAuthKeyN := m_nNewAuthKeyN;
          end;
        end
        else
        begin
          fAllWrOk := False;
          nMax := 255;
          SetLength(s, nMax);
          z2mGetErrorText(nRet, PChar(s), nMax);
          SetLength(s, nMax);
          if MessageDlg(format(SMSG_WRITEBLOCKERR2, [i+1, s]), mtError,
            [mbOk, mbCancel], 0)<>mrOk then exit;
        end;
      end;
      Application.ProcessMessages;
      pbTransfer.StepIt;
    end;
  finally
    pbTransfer.Visible := False;
  end;
  SetModifyFlag(not fAllWrOk);
  Result := True;
end;

procedure Tfm1K.UpdateKeyMask();
var
  oFile: TFileStream;
  sPath: String;
  i: Integer;
  aBuf: packed array[0..13] of BYTE;
begin
  lbKeyMask.Items.BeginUpdate;
  try
    lbKeyMask.Items.Clear;
    sPath := GetRdAKFilePath();
    if FileExists(sPath) then
    begin
      oFile := TFileStream.Create(sPath, fmOpenRead or fmShareExclusive);
      try
        for i := 0 to 15 do
        begin
          oFile.ReadBuffer(aBuf[0], 14);
          if (aBuf[0]=0) and (aBuf[7]=0) then continue;
          lbKeyMask.Items.Add(IntToStr(i+1));
        end;
      finally
        oFile.Free;
      end;
    end;
  finally
    lbKeyMask.Items.EndUpdate;
  end;
end;

procedure Tfm1K.SetModifyFlag(AModify: Boolean);
begin
  if AModify then
  begin
    m_fAsHexUpd := False;
    m_fAsTextUpd := False;
  end;
  if m_fChanged = AModify then exit;
  m_fChanged := AModify;
  UpdatePanInfo();
  UpdateControl();
end;

function Tfm1K.GetKeyMask(): Tz2mAKMask;
var
  i: Integer;
  k: Integer;
begin
  Result := 0;
  for i := 0 to lbKeyMask.Count - 1 do
  begin
    if lbKeyMask.Checked[i] then
    begin
      k := StrToInt(lbKeyMask.Items[i]);
      SetBit(Cardinal(Result), k);
    end;
  end;
end;

procedure Tfm1K.DoneHexCellEdit(ACancel: Boolean);
var
  s: string;
  n: Integer;
begin
  if not m_fCellEdit then exit;
  if m_nCurDViewN<>0 then exit;
  if ACancel then
  begin
    UpdateHexCell(m_nCurHexCol, m_nCurHexRow);
  end
  else
  begin
    s := gridDataAsHex.Cells[m_nCurHexCol, m_nCurHexRow];
    if Length(s)>0 then
    begin
      n := HexToInt(s);
      m_aNewSectData[m_nCurHexRow-1, m_nCurHexCol-1] := n;
      if m_aOldSectData[m_nCurHexRow-1, m_nCurHexCol-1] <>
        m_aNewSectData[m_nCurHexRow-1, m_nCurHexCol-1] then
        SetModifyFlag(True);
      if not m_aInitBlock[m_nCurHexRow-1] then
        m_aInitBlock[m_nCurHexRow-1] := True;
    end
    else
      UpdateHexCell(m_nCurHexCol, m_nCurHexRow);
  end;
  gridDataAsHex.Invalidate;
  m_fCellEdit := False;
  m_nHexCellSubN := 0;
end;

procedure Tfm1K.NextHexCellEdit();
var
  fTabOk: Boolean;
  i, j, i0, j0: Integer;
  tip: TCellAttrs;
begin
  DoneHexCellEdit(False);
  fTabOk := False;
  i := m_nCurHexRow;
  if m_nCurHexCol = -1 then j0 := 1 else j0 := m_nCurHexCol;
  if m_nCurHexRow = -1 then i0 := 1 else i0 := m_nCurHexRow;

  //     
  for j := j0+1 to 16 do
  begin
    tip := GetOldHexCellTip(j, i0);
    if (caWrite in tip) then
      begin fTabOk := True; break; end;
  end;
  //     
  if not fTabOk then
  begin
    for i := i0+1 to 3 do
    begin
      for j := 1 to 16 do
      begin
        tip := GetOldHexCellTip(j, i);
        if (caWrite in tip) then
          begin fTabOk := True; break; end;
      end;
      if fTabOk then break;
    end;
  end;
  //        
  if not fTabOk then
  begin
    for i := 1 to i0-1 do
    begin
      for j := 1 to 16 do
      begin
        tip := GetOldHexCellTip(j, i);
        if (caWrite in tip) then
          begin fTabOk := True; break; end;
      end;
      if fTabOk then break;
    end;
  end;
  //        
  if not fTabOk then
  begin
    for j := 0 to j0-1 do
    begin
      tip := GetOldHexCellTip(j, i0);
      if (caWrite in tip) then
        begin fTabOk := True; break; end;
    end;
  end;
  if fTabOk then
  begin
    gridDataAsHex.Col := j;
    gridDataAsHex.Row := i;
    gridDataAsHex.Invalidate;
  end;
end;

function Tfm1K.GetHexCellTip(Const ACol, ARow: Integer; var AData: T1KSectData): TCellAttrs;
var
  nAcc: BYTE;
begin
  Result := [];
  if (ACol <= 0) or (ACol > 16) or (ARow <= 0) or (ARow > 4) then
    begin Result := Result+[caFrame]; exit; end;

  z2mDecodeMfAccBits(ARow-1, @AData[3,6], @nAcc);
  case m_nKeyMode2 of
    Z2M_K_KeyA:
    begin
      case ARow of
        1..3: // Data
        begin
          Result := Result+[caData];
          if nAcc in [0 (*0 0 0*),
                      2 (*0 1 0*),
                      4 (*1 0 0*),
                      6 (*1 1 0*),
                      1 (*0 0 1*)] then Result := Result+[caRead];
          if nAcc in [0 (*0 0 0*)] then Result := Result+[caWrite];
          if nAcc in [0 (*0 0 0*)] then Result := Result+[caInc];
          if nAcc in [0 (*0 0 0*),
                      6 (*1 1 0*),
                      1 (*0 0 1*)] then Result := Result+[caDec];
        end;
        4: // Trailer
        begin
          Result := Result+[caTrailer];
          case ACol of
            1..6:   // Access for Key A
            begin
              Result := Result+[caKey];
              if nAcc in [0 (*0 0 0*),
                          1 (*0 0 1*)] then Result := Result+[caWrite];
            end;
            7..10:  // Access for Access Bits
            begin
              Result := Result+[caRead];
              if nAcc in [1 (*0 0 1*)] then Result := Result+[caWrite];
            end;
            11..16: // Access for Key B
            begin
            Result := Result+[caKey];
              if nAcc in [0 (*0 0 0*),
                          2(*0 1 0*),
                          1 (*0 0 1*)] then
              begin
                Result := Result+[caRead];
              end;
              if nAcc in [0 (*0 0 0*),
                          1(*0 0 1*)] then Result := Result+[caWrite];
            end;
          end;
        end;
      end;
    end;
    Z2M_K_KeyB:
    begin
      case ARow of
        1..3: // Data
        begin
          Result := Result+[caData];
          if not (nAcc in [7 (*1 1 1*)])  then Result := Result+[caRead];
          if nAcc in [0 (*0 0 0*),
                      4 (*1 0 0*),
                      6 (*1 1 0*),
                      3(*0 1 1*)] then Result := Result+[caWrite];
          if nAcc in [0 (*0 0 0*),
                      6 (*1 1 0*)] then Result := Result+[caInc];
          if nAcc in [0 (*0 0 0*),
                      6 (*1 1 0*),
                      1 (*0 0 1*)] then Result := Result+[caDec];
        end;
        4: // Trailer
        begin
          Result := Result+[caTrailer];
          case ACol of
            1..6:   // Access for Key A
            begin
              Result := Result+[caKey];
              if nAcc in [4 (*1 0 0*),
                          3 (*0 1 1*)] then Result := Result+[caWrite];
            end;
            7..10:  // Access for Access Bits
            begin
              if nAcc in [4 (*1 0 0*),
                          6 (*1 1 0*),
                          3(*0 1 1*),
                          5(*1 0 1*),
                          7(*1 1 1*)] then Result := Result+[caRead];
              if nAcc in [3(*0 1 1*),
                          5(*1 0 1*)] then Result := Result+[caWrite];
            end;
            11..16: // Access for Key B
            begin
              Result := Result+[caKey];
              if nAcc in [4 (*1 0 0*),
                          3(*0 1 1*)] then Result := Result+[caWrite];
            end;
          end;
        end;
      end;
    end;
  end;
  if (ARow = 1) and (m_nCurSectN=0) then
  begin
    Result := Result+[caManuf];
    Result := Result-[caWrite];
  end;
end;

function Tfm1K.GetOldHexCellTip(Const ACol, ARow: Integer): TCellAttrs;
begin
  Result := GetHexCellTip(ACol, ARow, m_aOldSectData);
end;

function Tfm1K.GetNewHexCellTip(Const ACol, ARow: Integer): TCellAttrs;
begin
  Result := GetHexCellTip(ACol, ARow, m_aNewSectData);
end;

procedure Tfm1K.rgAKModeClick(Sender: TObject);
begin
  SetAKMode(GetRadioAKIdxToMode(rgAKMode.ItemIndex));
end;

procedure Tfm1K.rgTxtFmtClick(Sender: TObject);
var
  tfm: TTxtFmtMode;
begin
  if rgTxtFmt.Buttons[0].Checked then
    tfm := tfmOem
  else
    tfm := tfmAnsi;
  SetTextFmtMode(tfm, False);
end;

procedure Tfm1K.gridDataAsHexDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
Const
  c_X = '?';
var
  grid: TStringGrid;
  s: String;
  hcaOld: TCellAttrs;
  dx, dy: integer;
  a, b: Integer;
  rc: TRect;
  bkcl, tc: TColor;
  sty: TFontStyles;
begin
  grid := (Sender as TStringGrid);
  if m_nCurDViewN<>0 then exit;
  with grid.Canvas do
  begin
    Font := grid.Font;
    hcaOld := GetNewHexCellTip(ACol, ARow);
    if caFrame in hcaOld then
    begin
      {   }
      Brush.Color := grid.FixedColor;
      FillRect(Rect);
      Font.Color := clBlue;
      s := grid.Cells[ACol, ARow];
      dx := TextWidth(s) + 2;
      dy := TextHeight(s) + 2;

      if (ACol=0) and (ARow=(m_nCurBlockN+1)) then
      begin
        Font.Style := Font.Style + [fsBold];
        Font.Size := grid.Font.Size + 5;
      end;
      TextOut(
        (Rect.Left+Rect.Right-dx)div 2,
        (Rect.Top+Rect.Bottom-dy)div 2,
        s);
    end
    else
    begin
      bkcl := grid.Color;
      sty := Font.Style;
      tc := Font.Color;
      if caManuf in hcaOld then bkcl := shLegSN.Brush.Color
      else if caData in hcaOld then
      begin
        if (caWrite in hcaOld) and (caRead in hcaOld) then
          bkcl := shLegRWData.Brush.Color
        else if caRead in hcaOld then
        begin
          bkcl := shLegRData.Brush.Color;
          sty := [fsBold];
          tc := clWhite;
        end
        else
        begin
          bkcl := shLegFData.Brush.Color;
          tc := clWhite;
        end;
      end
      else if caTrailer in hcaOld then
      begin
        if caKey in hcaOld then
        begin
          if (caRead in hcaOld) and (caWrite in hcaOld) then
            bkcl := shLegRWData.Brush.Color
          else if (caRead in hcaOld) then
            bkcl := shLegRKey.Brush.Color
          else if (caWrite in hcaOld) then bkcl := shLegWKey.Brush.Color
          else bkcl := shLegLKey.Brush.Color;
        end
        else
        begin
          if caWrite in hcaOld then
            bkcl := shLegRWAccess.Brush.Color
          else
            bkcl := shLegRAccess.Brush.Color;
        end;
      end;
      Font.Style := sty;
      Font.Color := tc;
      Brush.Color := bkcl;
      Brush.Style := bsSolid;
      FillRect(Rect);
      Pen.Width := 1;

      s := grid.Cells[ACol, ARow];
      dx := TextWidth(s) + 2;
      dy := TextHeight(s) + 2;
      if (ARow=(m_nCurBlockN+1)) then
      begin
        Pen.Color := clLtGray;
        if ACol=1 then
        begin
          MoveTo(Rect.Left, Rect.Top);
          LineTo(Rect.Left, Rect.Bottom);
        end;
        MoveTo(Rect.Left, Rect.Top);
        LineTo(Rect.Right, Rect.Top);

        Pen.Color := clDkGray;
        if ACol=16 then
        begin
          MoveTo(Rect.Right, Rect.Top);
          LineTo(Rect.Right, Rect.Bottom);
        end;
        MoveTo(Rect.Left, Rect.Bottom-1);
        LineTo(Rect.Right, Rect.Bottom-1);
      end;

      if (ACol = m_nCurHexCol) and (ARow = m_nCurHexRow) then
      begin
        Pen.Color := clBlack;
        Pen.Width := 3;
        rc := Rect;
        Brush.Style := bsClear;
        Rectangle(rc);
      end;

      SetBkMode(Handle, TRANSPARENT);
      if (ARow in [1..4]) and (not m_aInitBlock[ARow-1]) and
        (not m_fCellEdit) then
      begin
        Font.Style := Font.Style-[fsBold];
        Font.Size := grid.Font.Size+2;
        a := TextWidth(c_X)+2;
        b := TextHeight(c_X) + 2;
        TextOut(
          (Rect.Left+Rect.Right-a)div 2,
          (Rect.Top+Rect.Bottom-b)div 2,
          c_X);
      end
      else
      begin
        TextOut(
          (Rect.Left+Rect.Right-dx)div 2,
          (Rect.Top+Rect.Bottom-dy)div 2,
          s);
      end;

      if (ACol = m_nCurHexCol) and (ARow = m_nCurHexRow)
        and m_fCellEdit and (m_nHexCellSubN > 0) then
      begin
        a := TextWidth(Copy(s, 1, m_nHexCellSubN-1));
        b := TextWidth(Copy(s, m_nHexCellSubN, 1));
        Font.Color := clBlue;
        rc.Left := (Rect.Left+Rect.Right-dx)div 2+a;
        rc.Right := rc.Left+b;
        rc.Top := (Rect.Top+Rect.Bottom-dy)div 2+dy;
        rc.Bottom := rc.Top;
        Pen.Width := 1;
        Pen.Color := tc;
        MoveTo(rc.Left, rc.Top);
        LineTo(rc.Right, rc.Bottom);
      end;
    end;
  end
end;

procedure Tfm1K.gridDataAsHexKeyPress(Sender: TObject; var Key: Char);
var
  grid: TStringGrid;
  s: String;
  s2: String;
  hcaOld: TCellAttrs;
begin
  if (m_nCurHexCol <= 0) or (m_nCurHexRow <= 0) then exit;
  if m_nCurDViewN<>0 then exit;
  grid := (Sender as TStringGrid);
  case Key of
    #27: begin DoneHexCellEdit(True); exit end;
    #13: begin DoneHexCellEdit(False); NextHexCellEdit(); exit end;
  end;
  if (not m_fCellEdit) then
  begin
    hcaOld := GetOldHexCellTip(m_nCurHexCol, m_nCurHexRow);
    if not (caWrite in hcaOld) then exit;
  end;
  s := grid.Cells[m_nCurHexCol, m_nCurHexRow];
  case Key of
    '0'..'9','a'..'f','A'..'F':
    begin
      if (not m_fCellEdit) then
        m_nHexCellSubN := 1;
      if CharInSet(Key, ['a'..'f']) then
        s[m_nHexCellSubN] := Chr(Ord(Key)+Ord('A')-Ord('a'))
      else
        s[m_nHexCellSubN] := Key;
        Inc(m_nHexCellSubN);
        grid.Cells[m_nCurHexCol, m_nCurHexRow] := s;
        m_fCellEdit := True;
    end;
    #8:
    begin
      if (not m_fCellEdit) or (m_nHexCellSubN <= 0) then exit;
      if m_nHexCellSubN > 1 then
        Dec(m_nHexCellSubN);
      s2 := format('%.2X', [m_aNewSectData[m_nCurHexRow-1, m_nCurHexCol-1]]);
      s[m_nHexCellSubN] := s2[m_nHexCellSubN];
      grid.Cells[m_nCurHexCol, m_nCurHexRow] := s;
      m_fCellEdit := True;
    end;
    #32: if GetKeyState(VK_CONTROL) and $80 <> 0 then
    begin
      if (not m_fCellEdit) then
        m_nHexCellSubN := 1;
      s2 := format('%.2X', [m_aNewSectData[m_nCurHexRow-1, m_nCurHexCol-1]]);
      s[m_nHexCellSubN] := s2[m_nHexCellSubN];
      Inc(m_nHexCellSubN);
      grid.Cells[m_nCurHexCol, m_nCurHexRow] := s;
      m_fCellEdit := True;
    end;
  end;
  if m_fCellEdit and (m_nHexCellSubN > 2) then
  begin
    DoneHexCellEdit(False);
    NextHexCellEdit();
  end;
end;

procedure Tfm1K.gridDataAsHexSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  CanSelect := (ACol >= 1) and (ARow >= 1);
  if CanSelect and ((m_nCurHexCol <> ACol) or (m_nCurHexRow <> ARow)) then
  begin
    if ARow=4 then begin CanSelect := False; exit; end;
    DoneHexCellEdit(False);
    m_nCurHexCol := ACol;
    m_nCurHexRow := ARow;
    if (ARow-1)<>m_nCurBlockN then
    begin
      m_nCurBlockN := ARow-1;
      UpdateDataAcc();
    end;
    (Sender as TStringGrid).Invalidate;
  end;
end;

procedure Tfm1K.gridDataAsTextDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
Const
  c_X = '?';
var
  grid: TStringGrid;
  s: string;
  hcaOld: TCellAttrs;
  dx, dy: integer;
  rc: TRect;
  bkcl, tc: TColor;
  sty: TFontStyles;
  a,b: Integer;
begin
  grid := (Sender as TStringGrid);
  if m_nCurDViewN<>1 then exit;
  with grid.Canvas do
  begin
    Font := grid.Font;
    hcaOld := GetNewHexCellTip(ACol, ARow);
    if caFrame in hcaOld then
    begin
      {   }
      Brush.Color := grid.FixedColor;
      FillRect(Rect);
      Font.Color := clBlue;
      s := grid.Cells[ACol, ARow];
      dx := TextWidth(s) + 2;
      dy := TextHeight(s) + 2;

      if (ACol=0) and (ARow=(m_nCurBlockN+1)) then
      begin
        Font.Style := Font.Style + [fsBold];
        Font.Size := Font.Size + 5;
      end;
      TextOut(
        (Rect.Left+Rect.Right-dx)div 2,
        (Rect.Top+Rect.Bottom-dy)div 2,
        s);
    end
    else
    begin
      bkcl := grid.Color;
      sty := Font.Style;
      tc := Font.Color;
      if caManuf in hcaOld then bkcl := shLegSN.Brush.Color
      else if caData in hcaOld then
      begin
        if (caWrite in hcaOld) and (caRead in hcaOld) then
          bkcl := shLegRWData.Brush.Color
        else if caRead in hcaOld then
        begin
          bkcl := shLegRData.Brush.Color;
          sty := [fsBold];
          tc := clWhite;
        end
        else
        begin
          bkcl := shLegFData.Brush.Color;
          tc := clWhite;
        end;
      end;
      Font.Style := sty;
      Font.Color := tc;
      Brush.Color := bkcl;
      Brush.Style := bsSolid;
      FillRect(Rect);
      Pen.Width := 1;
      if (ARow=(m_nCurBlockN+1)) then
      begin
        Pen.Color := clLtGray;
        if ACol=1 then
        begin
          MoveTo(Rect.Left, Rect.Top);
          LineTo(Rect.Left, Rect.Bottom);
        end;
        MoveTo(Rect.Left, Rect.Top);
        LineTo(Rect.Right, Rect.Top);

        Pen.Color := clDkGray;
        if ACol=16 then
        begin
          MoveTo(Rect.Right, Rect.Top);
          LineTo(Rect.Right, Rect.Bottom);
        end;
        MoveTo(Rect.Left, Rect.Bottom-1);
        LineTo(Rect.Right, Rect.Bottom-1);
      end;

      s := grid.Cells[ACol, ARow];
      dx := TextWidth(s) + 2;
      dy := TextHeight(s) + 2;

      if (ACol = m_nCurTextCol) and (ARow = m_nCurTextRow) then
      begin
        Pen.Color := clBlack;
        Pen.Width := 3;
        rc := Rect;
        Brush.Style := bsClear;
        Rectangle(rc);
      end;

      SetBkMode(Handle, TRANSPARENT);
      if (ARow in [1..4]) and (not m_aInitBlock[ARow-1]) and
        (not m_fCellEdit) then
      begin
        Font.Style := Font.Style-[fsBold];
        Font.Size := grid.Font.Size+2;
        a := TextWidth(c_X)+2;
        b := TextHeight(c_X) + 2;
        TextOut(
          (Rect.Left+Rect.Right-a)div 2,
          (Rect.Top+Rect.Bottom-b)div 2,
          c_X);
      end
      else
      begin
        TextOut(
          (Rect.Left+Rect.Right-dx)div 2,
          (Rect.Top+Rect.Bottom-dy)div 2,
          s);
      end;
    end;
  end
end;

procedure Tfm1K.gridDataAsTextKeyPress(Sender: TObject; var Key: Char);
var
  grid: TStringGrid;
  s,s2: String;
begin
  grid := (Sender as TStringGrid);
  if m_nCurDViewN<>1 then exit;
  if (m_nCurTextCol <= 0) or (m_nCurTextRow <= 0) then exit;
  case Key of
    #27: begin DoneTextCellEdit(True); exit end;
    #13: begin DoneTextCellEdit(False); NextTextCellEdit(); exit end;
  end;
  s := grid.Cells[m_nCurTextCol, m_nCurTextRow];
  if IsCharAlphaNumeric(Key) or ((Key = #32) and (GetKeyState(VK_CONTROL)and$80 = 0)) then
  begin
    if (not m_fCellEdit) then
      m_nTextCellSubN := 1;
    s := Key;
    if m_nTextFmtMode = tfmOem then s := WinToDos(s);
    grid.Cells[m_nCurTextCol, m_nCurTextRow] := s;
    m_fCellEdit := True;
  end
  else
  begin
    case Key of
      #32: if GetKeyState(VK_CONTROL) and $80 <> 0 then
      begin
        if (not m_fCellEdit) then m_nTextCellSubN := 1;
        s := Chr(m_aNewSectData[m_nCurTextRow-1, m_nCurTextCol-1]);
        Inc(m_nTextCellSubN);
        if m_nTextFmtMode = tfmOem then s := DosToWin(s);
        grid.Cells[m_nCurTextCol, m_nCurTextRow] := s;
        m_fCellEdit := True;
      end;
      #8:
      begin
        if (not m_fCellEdit) or (m_nTextCellSubN <= 0) then exit;
        if m_nTextCellSubN > 1 then Dec(m_nTextCellSubN);
        s := Chr(m_aNewSectData[m_nCurTextRow-1, m_nCurTextCol-1]);
        if m_nTextFmtMode = tfmOem then s2 := DosToWin(s2);
        grid.Cells[m_nCurTextCol, m_nCurTextRow] := s;
        m_fCellEdit := True;
      end;
    end;
  end;
  if m_fCellEdit and (Length(s) >= 1) then
  begin
    DoneTextCellEdit(False);
    NextTextCellEdit();
  end;
end;

procedure Tfm1K.gridDataAsTextSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  CanSelect := (ACol >= 1) and (ARow >= 1);
  if CanSelect and ((m_nCurTextCol <> ACol) or (m_nCurTextRow <> ARow)) then
  begin
    DoneTextCellEdit(False);
    m_nCurTextCol := ACol;
    m_nCurTextRow := ARow;
    if (ARow-1)<>m_nCurBlockN then
    begin
      m_nCurBlockN := ARow-1;
      UpdateDataAcc();
    end;
    (Sender as TStringGrid).Invalidate;
  end
  else
    CanSelect := True;
end;

procedure Tfm1K.tvSectionDblClick(Sender: TObject);
var
  tv: TTreeView;
  MousePos: TPoint;
  Node: TTreeNode;
  nSectN: Integer;
  nViewN: Integer;
  f: Boolean;
begin
  tv := TTreeView(Sender);
  GetCursorPos(MousePos);
  MousePos := tv.ScreenToClient(MousePos);
  Node := (Sender as TTreeView).GetNodeAt(MousePos.X, MousePos.Y);
  if Node=nil then exit;
  tv.Items.BeginUpdate;
  try
    tv.Selected := Node;
    nViewN := -1;
    f := Node.Parent = nil;
    if Node.Parent = nil then nSectN := Node.Index
    else
    begin
      nSectN := Node.Parent.Index;
      if Node = Node.Parent.getFirstChild then
        nViewN := 0
      else if Node = Node.Parent.GetLastChild then
        nViewN := 1;
    end;
    if f and (nSectN = m_nCurSectN) then
      SetCurSect(-1)
    else
      SetCurSect(nSectN, nViewN);
  finally
    tv.Items.EndUpdate;
  end;
end;

procedure Tfm1K.tvSectionExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
  AllowExpansion := Node.Index = m_nCurSectN;
end;

procedure Tfm1K.tvSectionKeyPress(Sender: TObject; var Key: Char);
var
  tv: TTreeView;
  Node: TTreeNode;
  nSectN: Integer;
  nViewN: Integer;
  f: Boolean;
begin
  if Key<>#13 then exit;
  tv := TTreeView(Sender);
  Node := tv.Selected; if Node=nil then exit;
  nViewN := -1;
  f := Node.Parent = nil;
  if Node.Parent = nil then nSectN := Node.Index
  else
  begin
    nSectN := Node.Parent.Index;
    if Node = Node.Parent.getFirstChild then
      nViewN := 0
    else if Node = Node.Parent.GetLastChild then
      nViewN := 1;
  end;
  if f and (nSectN = m_nCurSectN) then
    SetCurSect(-1)
  else
    SetCurSect(nSectN, nViewN);
end;

procedure Tfm1K.btnApplyClick(Sender: TObject);
begin
  DoApply();
end;

procedure Tfm1K.btnChkAllClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to lbKeyMask.Count - 1 do
    lbKeyMask.Checked[i] := True;
end;

procedure Tfm1K.btnInputKeysClick(Sender: TObject);
begin
  fmInpKey := TfmInpKey.Create(Self);
  try
    fmInpKey.FRd  := FRd;
    fmInpKey.ShowModal; //  "   "
    UpdateKeyMask();
    UpdateAuthKeyN();
  finally
    FreeAndNil(fmInpKey);
  end;
end;

procedure Tfm1K.btnRefreshClick(Sender: TObject);
begin
  DoRefresh();
end;

procedure Tfm1K.btnUnchkAllClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to lbKeyMask.Count - 1 do
    lbKeyMask.Checked[i] := False;
end;

procedure Tfm1K.cbAuthKeyNChange(Sender: TObject);
var
  cb: TComboBox;
begin
  cb := (Sender as TComboBox);
  SetAuthKeyN(GetAKComboIdxToKeyN(cb.ItemIndex));
end;

procedure Tfm1K.cbDataAccChange(Sender: TObject);
var
  cb: TComboBox;
begin
  cb := (Sender as TComboBox);
  SetBlockAccess(m_nCurBlockN, cb.ItemIndex);
end;

procedure Tfm1K.cbDataAccDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  cb: TComboBox;
  S, S2: string;
  i: Integer;
  nP1, nP2: Integer;
  dx, x, y, cx: Integer;
begin
  cb := Control as TComboBox;
  with cb.Canvas do
  begin
    Brush.Color := clWindow;
    Font.Color := clWindowText;
    Pen.Color := clWindowText;
    if Index in [0,1,4] then
      Brush.Color := $00EBEBEB;
    FillRect(Rect);
    S := cb.Items[Index];
    dx := 0;
    nP1 := 1;  nP2 := 0;

    for i := 0 to nDataAccCols - 1 do
    begin
      cx := aDataAccCols[i];
      if nP1 <> 0 then
      begin
        nP2 := PosEx(';', S, nP1);
        if nP2 <> 0 then S2 := Copy(S, nP1, nP2-nP1)
        else S2 := Copy(S, nP1, Length(S)-nP1+1);
      end
      else S2 := '';
      x := dx+(cx-TextWidth(S2))div 2;
      y := Rect.Top+(Rect.Bottom-Rect.Top-TextHeight(S2)) div 2;
      TextOut(x, y, S2);
      MoveTo(dx+cx, Rect.Top);
      LineTo(dx+cx, Rect.Bottom);
      Inc(dx, cx);
      if nP2 = 0 then nP1 := 0 else nP1 := nP2+1;
    end;
  end;
end;

procedure Tfm1K.cbTrailerAccChange(Sender: TObject);
var
  cb: TComboBox;
begin
  cb := (Sender as TComboBox);
  SetBlockAccess(3, cb.ItemIndex);
end;

procedure Tfm1K.cbTrailerAccDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  cb: TComboBox;
  S, S2: string;
  i: Integer;
  nP1, nP2: Integer;
  dx, x, y, cx: Integer;
begin
  cb := Control as TComboBox;
  with cb.Canvas do
  begin
    Brush.Color := clWindow;
    Font.Color := clWindowText;
    Pen.Color := clWindowText;
    if Index in [0,1,4] then
      Brush.Color := $00EBEBEB;
    FillRect(Rect);
    S := cb.Items[Index];
    dx := 0;
    nP1 := 1;  nP2 := 0;

    for i := 0 to nTraAccCols - 1 do
    begin
      cx := aTraAccCols[i];
      if nP1 <> 0 then
      begin
        nP2 := PosEx(';', S, nP1);
        if nP2 <> 0 then S2 := Copy(S, nP1, nP2-nP1)
        else S2 := Copy(S, nP1, Length(S)-nP1+1);
      end
      else S2 := '';
      x := dx+(cx-TextWidth(S2))div 2;
      y := Rect.Top+(Rect.Bottom-Rect.Top-TextHeight(S2)) div 2;
      TextOut(x, y, S2);
      MoveTo(dx+cx, Rect.Top);
      LineTo(dx+cx, Rect.Bottom);
      Inc(dx, cx);
      if nP2 = 0 then nP1 := 0 else nP1 := nP2+1;
    end;
  end;
end;

procedure Tfm1K.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  // Init data
  m_nCurHexCol := -1;
  m_nCurHexRow := -1;
  m_fCellEdit := False;
  m_nHexCellSubN := 0;
  m_nTextFmtMode := tfmAnsi;
  m_nCurTextCol := -1;
  m_nCurTextRow := -1;
  m_fCellEdit := False;
  m_nTextCellSubN := 0;
  m_nCurSectN := -1;
  m_nLastTVSect := -1;
  m_nCurDViewN := -1;
  m_nKeyMode1 := Z2M_K_KeyA;
  m_nKeyMode2 := m_nKeyMode1;
  m_fCtrlLock := False;
  m_fDataInit := False;
  for i := 0 to High(m_aInitBlock) do m_aInitBlock[i] := False;
  m_fAsHexUpd := False;
  m_fAsTextUpd := False;
  m_nNewAuthKeyN := 0;
  m_hCd := 0;
  m_nCurSectN := -1; m_hSc := 0;
  m_nCurBlockN := 0;
  gridDataAsHex.Row:=1;
  gridDataAsText.Row:=1;

  // Init controls
  with gridDataAsHex.Rows[0] do
  begin
    BeginUpdate();
    try
      for i := 1 to 16 do Strings[i] := IntToStr(i);
    finally
      EndUpdate();
    end;
  end;
  with gridDataAsText.Rows[0] do
  begin
    BeginUpdate();
    try
      for i := 1 to 16 do Strings[i] := IntToStr(i);
    finally
      EndUpdate();
    end;
  end;
  with gridDataAsHex.Cols[0] do
  begin
    BeginUpdate;
    try
      for i := 1 to gridDataAsHex.ColCount do Strings[i] := IntToStr(i);
    finally
      EndUpdate;
    end;
  end;
  with gridDataAsText.Cols[0] do
  begin
    BeginUpdate;
    try
      for i := 1 to gridDataAsText.ColCount do Strings[i] := IntToStr(i);
    finally
      EndUpdate;
    end;
  end;
  edtCdTitle.Text := '';

  UpdateCurSect();
  UpdateControl();
  InitDataAccCapt();
  InitTrailerAccCapt();
end;

procedure Tfm1K.FormDestroy(Sender: TObject);
begin
  if m_hSc<>0 then z2mCloseMfSector(m_hSc);
  if m_hCd <> 0 then z2mCloseCard(m_hCd);
end;

procedure Tfm1K.FormShow(Sender: TObject);
begin
  m_fAfterDis := False;
  PostMessage(Handle, WM_POSTINITFORM, 0, 0);
  UpdatePanInfo();
end;

procedure Tfm1K.PostInitForm(var msg: TMessage);
var
  Info: Tz2mReaderInfo;
  nAKeyCount, nRet, nMax: Integer;
  s: String;
begin
  if FRd = 0 then exit;
  ZeroMemory(@info, SizeOf(info));
  nRet := z2mGetReaderInfo(FRd, @Info);
  if nRet <> Z2M_SUCCESS then
  begin
    MsgBoxZ2mErr(Handle, nRet);
    Close;
    exit;
  end;
  m_nRdSN   := Info.nSN;
  UpdateKeyMask();
  DoOpenCard();
  if m_hCd <> 0 then
  begin
    nAKeyCount := GetAuthKeyCount(m_nRdSN, Z2M_K_KeyA);
    if nAKeyCount=0 then
    begin
      if MessageDlg(SMSG_NOAKEY, mtConfirmation, [mbOk, mbCancel], 0) = mrOk then
      begin
        nRet := z2mSetAuthKey(FRd, Z2M_K_KeyA, 0, z2mDefAuthKey);
        if nRet = Z2M_SUCCESS then
          nRet := z2mSetAuthKey(FRd, Z2M_K_KeyB, 0, z2mDefAuthKey);

        if nRet = Z2M_SUCCESS then
        begin
          WriteAuthKeyToFile(m_nRdSN, 0, Z2M_K_KeyA, z2mDefAuthKey);
          WriteAuthKeyToFile(m_nRdSN, 0, Z2M_K_KeyB, z2mDefAuthKey);
          UpdateKeyMask();
        end
        else
        begin
          nMax := 255;
          SetLength(s, nMax);
          z2mGetErrorText(nRet, PChar(@s[1]), nMax);
          SetLength(s, nMax);
          MessageDlg(SERR_SETDEFAKEY+#13#10+S, mtError, [mbOk], 0);
        end;
      end;
    end;
  end;
end;

procedure Tfm1K.AddCardEvent(var msg: TMessage);
begin
  if m_hCd = 0 then DoOpenCard();
end;

procedure Tfm1K.RmvCardEvent(var msg: TMessage);
begin
  m_fAfterDis := True;
  DoCloseCard();
end;

procedure Tfm1K.DoOpenCard();
var
  nRet: Integer;
begin
  nRet := z2mOpenCard(@m_hCd, FRd, FCdTip, FCdId);
  if nRet <> Z2M_SUCCESS then m_hCd := 0;

  m_fDataInit := False;
  UpdatePanInfo();
  UpdatePanSect();
  UpdatePanView();
  if m_hCd <> 0 then
  begin
//    if m_fAfterDis then
//    begin
//      if MessageBox(Handle, Pchar(SMSG_DATARESTORE+#0),
//        PChar(''+#0), MB_YESNO or MB_ICONQUESTION) = IDYES then
//        ReReadData();
//    end;
  end
  else
  begin
    MsgBoxZ2mErr(Handle, nRet);
  end;
end;

procedure Tfm1K.DoCloseCard();
begin
  if m_hCd <> 0 then
  begin
    z2mCloseCard(m_hCd);
    m_hCd := 0;
  end;
  m_hSc := 0;
  m_nCurSectN := -1;
  m_nCurDViewN := -1;
  SetModifyFlag(False);
  UpdatePanInfo();
  UpdatePanSect();
  UpdatePanView();
end;

procedure Tfm1K.UpdatePanInfo();
var
  s: string;
begin
  if m_fChanged then s := '*' else s := '';
  edtCdTitle.Text := format('%s  %s  %s',
    [CdIdToStr(FCdId), CdTipToShortStr(FCdTip), s]);
  if m_hCd <> 0 then edtConStat.Text := SMSG_CONNECTED
  else edtConStat.Text := SMSG_DICONNECTED;
end;

procedure Tfm1K.UpdatePanSect();
var
  fValidCd: Boolean;
  tvi: TTVItem;
  tn: TTreeNode;
  n: Integer;
begin
  fValidCd := (m_hCd<>0);
  panSect.Enabled := fValidCd;
  tvSection.Enabled := fValidCd;
  if fValidCd then
  begin
    if m_nLastTVSect<>m_nCurSectN then
    begin
      FillChar(tvi, Sizeof(tvi), 0);
      tvi.mask := TVIF_STATE;
      tvi.stateMask := TVIS_BOLD;
      if m_nLastTVSect<>-1 then
      begin
        tn := GetTVNodeOfIndex(tvSection.Items, m_nLastTVSect);
        assert(tn<>nil);
        tvi.hItem := tn.ItemID;
        tvi.state := 0;
        TreeView_SetItem(tvSection.Handle, tvi);
        tn.Expanded := False;
      end;
      m_nLastTVSect := m_nCurSectN;
      if m_nLastTVSect<>-1 then
      begin
        tn := GetTVNodeOfIndex(tvSection.Items, m_nLastTVSect);
        assert(tn<>nil);
        tvi.hItem := tn.ItemID;
        tvi.state := TVIS_BOLD;
        TreeView_SetItem(tvSection.Handle, tvi);
        tn.Expanded := True;
      end;
      tvSection.Update;
    end;
    n := GetRadioAKModeToIdx(m_nKeyMode2);
    if n<>rgAKMode.ItemIndex then
      rgAKMode.ItemIndex := n;
  end;
end;

procedure Tfm1K.UpdatePanView();
begin
  panView.Enabled := (m_hSc<>0)and(m_nCurSectN<>-1);
  UpdateAuthKeyN();
  UpdateDataAcc();
  UpdateTrailAcc();
  UpdateCurDataView();
  UpdateControl();
end;

procedure Tfm1K.UpdateAuthKeyN();
var
  i: Integer;
begin
  cbAuthKeyN.Enabled := (m_hSc<>0)and(m_nCurSectN<>-1);
  if cbAuthKeyN.Enabled then
  begin
    cbAuthKeyN.Items.BeginUpdate;
    try
      cbAuthKeyN.Items.Clear;
      for i := 0 to lbKeyMask.Items.Count - 1 do
        cbAuthKeyN.Items.Add(lbKeyMask.Items[i]);
    finally
      cbAuthKeyN.Items.EndUpdate;
    end;
    cbAuthKeyN.ItemIndex := GetAKComboKeyNToIdx(m_nNewAuthKeyN);
  end
  else
  begin
    cbAuthKeyN.ItemIndex := -1;
  end;
end;

procedure Tfm1K.UpdateDataAcc();
var
  nAcc: Byte;
begin
  cbDataAcc.Enabled := (m_nCurSectN<>-1)and
                      (m_nCurBlockN in [0..2])and
                      m_fDataInit;
  if cbDataAcc.Enabled then
  begin
    z2mDecodeMfAccBits(m_nCurBlockN, @m_aNewSectData[3, 6], @nAcc);
    cbDataAcc.ItemIndex := AccessBitsToState(nAcc);
  end
  else
  begin
    if cbDataAcc.ItemIndex <> -1 then
      cbDataAcc.ItemIndex := -1;
  end;
end;

procedure Tfm1K.UpdateTrailAcc();
var
  nAcc: BYTE;
begin
  cbTrailerAcc.Enabled := (m_nCurSectN<>-1)and m_fDataInit;
  if cbTrailerAcc.Enabled then
  begin
    z2mDecodeMfAccBits(3, @m_aNewSectData[3, 6], @nAcc);
    cbTrailerAcc.ItemIndex := AccessBitsToState(nAcc);
  end
  else
  begin
    if cbTrailerAcc.ItemIndex <> -1 then
      cbTrailerAcc.ItemIndex := -1;
  end;
end;

procedure Tfm1K.UpdateCurDataView();
var
  i,j: Integer;
begin
  grDataView.Enabled := (m_nCurSectN<>-1)and m_fDataInit;
  pcBlockData.Enabled := (m_nCurDViewN <> -1);
  if pcBlockData.ActivePageIndex <> m_nCurDViewN then
    pcBlockData.ActivePageIndex := m_nCurDViewN;
  if gridDataAsHex.Row <> (m_nCurBlockN+1) then
    gridDataAsHex.Row := m_nCurBlockN+1;
  if gridDataAsText.Row <> (m_nCurBlockN+1) then
    gridDataAsText.Row := m_nCurBlockN+1;
  if m_fDataInit then
  begin
    case m_nCurDViewN of
      0:
      begin
        m_nCurHexCol := gridDataAsHex.Col;
        m_nCurHexRow := gridDataAsHex.Row;
        if not m_fAsHexUpd then
        begin
          m_fAsHexUpd := True;
          for i := 1 to 4 do
          begin
            for j := 1 to 16 do
              UpdateHexCell(j,i);
          end;
          gridDataAsHex.Invalidate;
        end;
      end;
      1:
      begin
        m_nCurTextCol := gridDataAsText.Col;
        m_nCurTextRow := gridDataAsText.Row;
        if not m_fAsTextUpd then
        begin
          m_fAsTextUpd := True;
          for i := 1 to 3 do
          begin
            for j := 1 to 16 do
              UpdateTextCell(j,i);
          end;
          gridDataAsText.Invalidate;
          UpdateTextFmtMode();
        end;
      end;
    end;
  end;
end;

procedure Tfm1K.UpdateControl();
begin
  btnApply.Enabled := (m_hSc<>0) and (m_nCurSectN <> -1) and m_fChanged;
  btnRefresh.Enabled := (m_hSc<>0) and (m_nCurSectN <> -1);
end;

procedure Tfm1K.UpdateTextFmtMode();
begin
  case m_nTextFmtMode of
    tfmOem: if not rgTxtFmt.Buttons[0].Checked then rgTxtFmt.Buttons[0].Checked := True;
    tfmAnsi: if not rgTxtFmt.Buttons[1].Checked then rgTxtFmt.Buttons[1].Checked  := True;
  end;
end;

procedure Tfm1K.InitDataAccCapt();
Const
  sCapt = 'State'+#9+'Read'+#9+'Write'+#9+
          'Increment'+#9+'Decrement, transfer, restore'+#9+'Application';
var
  S2: string;
  i: Integer;
  nP1, nP2: Integer;
  dx, cx: Integer;
  rcText: TRect;
  a,b: Integer;
begin
  with imgDataAcc.Canvas do
  begin
    Font.Size := 7;
    Brush.Color := clBtnFace;
    Rectangle(imgDataAcc.ClientRect);
    dx := imgDataAcc.ClientRect.Left;
    nP1 := 1;  nP2 := 0;
    for i := 0 to nDataAccCols - 1 do
    begin
      cx := aDataAccCols[i];
      if nP1 <> 0 then
      begin
        nP2 := PosEx(#9, sCapt, nP1);
        if nP2 <> 0 then S2 := Copy(sCapt, nP1, nP2-nP1)
        else S2 := Copy(sCapt, nP1, Length(sCapt)-nP1+1);
      end
      else S2 := '';
      rcText.Left := dx;
      rcText.Right := dx+cx;
      rcText.Top := imgDataAcc.ClientRect.Top;
      rcText.Bottom := imgDataAcc.ClientRect.Bottom;

      DrawText(Handle, PChar(S2+#0), -1, rcText, DT_CALCRECT or DT_WORDBREAK);
      a := (rcText.Bottom-rcText.Top);
      if rcText.Bottom < imgDataAcc.ClientRect.Bottom then
      begin
        rcText.Top := imgDataAcc.ClientRect.Top+
          (imgDataAcc.ClientRect.Bottom-imgDataAcc.ClientRect.Top-a) div 2;
        rcText.Bottom := rcText.Top + a;
      end;
      b := (rcText.Right-rcText.Left);
      if rcText.Right < (dx+cx) then
      begin
        rcText.Left := dx+(cx-b) div 2;
        rcText.Right := rcText.Left + b;
      end;

      DrawText(Handle, PChar(S2+#0), -1, rcText, DT_WORDBREAK);
      MoveTo(dx+cx, imgDataAcc.ClientRect.Top);
      LineTo(dx+cx, imgDataAcc.ClientRect.Bottom);
      Inc(dx, cx);
      if nP2 = 0 then nP1 := 0 else nP1 := nP2+1;
    end;
  end;
end;

procedure Tfm1K.InitTrailerAccCapt();
Const
  sCapt = 'State'+#9+'Read A'+#9+'Write A'+#9+
          'Read Access'+#9+'Write Access'+#9+
          'Read B'+#9+'Write B'+#9+'Remark';
var
  S2: string;
  i: Integer;
  nP1, nP2: Integer;
  dx, cx: Integer;
  rcText: TRect;
  a,b: Integer;
begin
  with imgTrailerAcc.Canvas do
  begin
    Font.Size := 7;
    Brush.Color := clBtnFace;
    Rectangle(imgTrailerAcc.ClientRect);
    dx := imgTrailerAcc.ClientRect.Left;
    nP1 := 1;  nP2 := 0;
    for i := 0 to nTraAccCols - 1 do
    begin
      cx := aTraAccCols[i];
      if nP1 <> 0 then
      begin
        nP2 := PosEx(#9, sCapt, nP1);
        if nP2 <> 0 then S2 := Copy(sCapt, nP1, nP2-nP1)
        else S2 := Copy(sCapt, nP1, Length(sCapt)-nP1+1);
      end
      else S2 := '';
      rcText.Left := dx;
      rcText.Right := dx+cx;
      rcText.Top := imgTrailerAcc.ClientRect.Top;
      rcText.Bottom := imgTrailerAcc.ClientRect.Bottom;

      DrawText(Handle, PChar(S2+#0), -1, rcText, DT_CALCRECT or DT_WORDBREAK);
      a := (rcText.Bottom-rcText.Top);
      if rcText.Bottom < imgTrailerAcc.ClientRect.Bottom then
      begin
        rcText.Top := imgTrailerAcc.ClientRect.Top+
          (imgTrailerAcc.ClientRect.Bottom-
          imgTrailerAcc.ClientRect.Top-a) div 2;
        rcText.Bottom := rcText.Top + a;
      end;
      b := (rcText.Right-rcText.Left);
      if rcText.Right < (dx+cx) then
      begin
        rcText.Left := dx+(cx-b) div 2;
        rcText.Right := rcText.Left + b;
      end;

      DrawText(Handle, PChar(S2+#0), -1, rcText, DT_WORDBREAK);
      MoveTo(dx+cx, imgTrailerAcc.ClientRect.Top);
      LineTo(dx+cx, imgTrailerAcc.ClientRect.Bottom);
      Inc(dx, cx);
      if nP2 = 0 then nP1 := 0 else nP1 := nP2+1;
    end;
  end;
end;

function Tfm1K.GetRdAKFilePath(): String;
begin
  Result := GetRdAuthKeysFilePath(m_nRdSN);
end;

function Tfm1K.GetAKComboKeyNToIdx(AKeyN: Integer): Integer;
var
  i: Integer;
begin
  for i := 0 to cbAuthKeyN.Items.Count - 1 do
  begin
    if StrToInt(cbAuthKeyN.Items[i])=AKeyN then
    begin
      Result := i;
      exit;
    end;
  end;
  Result := -1;
end;

function Tfm1K.GetAKComboIdxToKeyN(AIdx: Integer): Integer;
begin
  if AIdx<>-1 then
  begin
    Result := StrToInt(cbAuthKeyN.Items[AIdx]);
  end
  else
    Result := -1;
end;

function Tfm1K.GetRadioAKModeToIdx(AMode: Tz2mAKMode): Integer;
begin
  if AMode = Z2M_K_KeyB then Result := 1 else Result := 0;
end;

function Tfm1K.GetRadioAKIdxToMode(AIdx: Integer): Tz2mAKMode;
begin
  if AIdx=1 then Result := Z2M_K_KeyB else Result := Z2M_K_KeyA;
end;

procedure Tfm1K.UpdateCurSect();
var
  nd: TTreeNode;
begin
  if m_nCurSectN = -1 then
    tvSection.Selected := nil
  else
  begin
    nd := tvSection.Items[m_nCurSectN];
    case m_nCurDViewN of
      0: nd := nd.getFirstChild;
      1: nd := nd.GetLastChild;
    end;
    tvSection.TopItem := nd;
    tvSection.Selected := nd;
  end;
end;

procedure Tfm1K.UpdateHexCell(Const ACol, ARow: Integer);
var
  s: string;
begin
  if (ARow < 1) or (ACol < 1) then exit;
  s := IntToHex(m_aNewSectData[ARow-1, ACol-1], 2);
  gridDataAsHex.Cells[ACol, ARow] := s;
end;

procedure Tfm1K.UpdateTrailer();
var
  i: Integer;
  s: string;
begin
  for i := 0 to 15 do
  begin
    s := IntToHex(m_aNewSectData[3, i], 2);
    gridDataAsHex.Cells[i+1, 4] := s;
  end;
  gridDataAsHex.Invalidate;
end;

procedure Tfm1K.UpdateTextCell(Const ACol, ARow: Integer);
var
  s: string;
begin
  if (ARow < 1) or (ACol < 1) then exit;
  s := Chr(m_aNewSectData[ARow-1, ACol-1]);
  if m_nTextFmtMode = tfmOem then s := DosToWin(s);
  gridDataAsText.Cells[ACol, ARow] := s;
end;

procedure Tfm1K.DoneTextCellEdit(ACancel: Boolean);
var
  s: string;
  bt: BYTE;
begin
  if not m_fCellEdit then exit;
  if m_nCurDViewN<>1 then exit;
  if ACancel then
    UpdateTextCell(m_nCurTextCol, m_nCurTextRow)
  else
  begin
    s := gridDataAsText.Cells[m_nCurTextCol, m_nCurTextRow];
    if m_nTextFmtMode = tfmOem then
      s := WinToDos(s);
    bt := Ord(s[1]);
    m_aNewSectData[m_nCurTextRow-1, m_nCurTextCol-1] := bt;
    if m_aOldSectData[m_nCurTextRow-1, m_nCurTextCol-1] <>
      m_aNewSectData[m_nCurTextRow-1, m_nCurTextCol-1] then
      SetModifyFlag(True);
    if not m_aInitBlock[m_nCurTextRow-1] then
      m_aInitBlock[m_nCurTextRow-1] := True;
  end;
  gridDataAsText.Invalidate;
  m_fCellEdit := False;
end;

procedure Tfm1K.NextTextCellEdit();
var
  fTabOk: Boolean;
  i, j, i0, j0: Integer;
  tip: TCellAttrs;
begin
  DoneTextCellEdit(False);
  fTabOk := False;
  i := m_nCurTextRow;
  if m_nCurTextCol = -1 then j0 := 1 else j0 := m_nCurTextCol;
  if m_nCurTextRow = -1 then i0 := 1 else i0 := m_nCurTextRow;

  //     
  for j := j0+1 to 16 do
  begin
    tip := GetOldHexCellTip(j, i0);
    if (caWrite in tip) then
      begin fTabOk := True; break; end;
  end;
  //     
  if not fTabOk then
  begin
    for i := i0+1 to 3 do
    begin
      for j := 1 to 16 do
      begin
        tip := GetOldHexCellTip(j, i);
        if (caWrite in tip) then
          begin fTabOk := True; break; end;
      end;
      if fTabOk then break;
    end;
  end;
  //        
  if not fTabOk then
  begin
    for i := 1 to i0-1 do
    begin
      for j := 1 to 16 do
      begin
        tip := GetOldHexCellTip(j, i);
        if (caWrite in tip) then
          begin fTabOk := True; break; end;
      end;
      if fTabOk then break;
    end;
  end;
  //        
  if not fTabOk then
  begin
    for j := 0 to j0-1 do
    begin
      tip := GetOldHexCellTip(j, i0);
      if (caWrite in tip) then
        begin fTabOk := True; break; end;
    end;
  end;
  if fTabOk then
  begin
    gridDataAsText.Col := j;
    gridDataAsText.Row := i;
    gridDataAsText.Invalidate;
  end;
end;

procedure Tfm1K.pcBlockDataChange(Sender: TObject);
var
  pgc: TPageControl;
begin
  pgc := Sender as TPageControl;
  SetCurDView(pgc.TabIndex);
end;

procedure Tfm1K.DoneCellEdit(ACancel: Boolean);
begin
  case m_nCurDViewN of
    0: DoneHexCellEdit(ACancel);
    1: DoneTextCellEdit(ACancel);
  end;
end;

end.
