unit uIndicators;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  z2m, Mask, JvExMask, JvSpin;

type
  TIndRow = record
    chkUse: TCheckBox;
    cbRed: TComboBox;
    cbGreen: TComboBox;
    cbSound: TComboBox;
    edtTime: TJvSpinEdit;
  end;
  TfmIndicators = class(TForm)
    GroupBox1: TGroupBox;
    btnClose: TButton;
    btnPlay: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    StaticText2: TStaticText;
    StaticText1: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    chkUse1: TCheckBox;
    cbRed1: TComboBox;
    cbGreen1: TComboBox;
    cbSound1: TComboBox;
    edtTime1: TJvSpinEdit;
    GroupBox4: TGroupBox;
    btnSoundOn: TButton;
    btnSoundOff: TButton;
    btnSoundAuto: TButton;
    GroupBox3: TGroupBox;
    btnGreenOn: TButton;
    btnGreenOff: TButton;
    btnGreenAuto: TButton;
    GroupBox2: TGroupBox;
    btnRedOn: TButton;
    btnRedOff: TButton;
    btnRedAuto: TButton;
    btnbreak: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnPlayClick(Sender: TObject);
    procedure btnRedOnClick(Sender: TObject);
    procedure btnRedOffClick(Sender: TObject);
    procedure btnRedAutoClick(Sender: TObject);
    procedure btnGreenOnClick(Sender: TObject);
    procedure btnGreenOffClick(Sender: TObject);
    procedure btnGreenAutoClick(Sender: TObject);
    procedure btnSoundOnClick(Sender: TObject);
    procedure btnSoundOffClick(Sender: TObject);
    procedure btnSoundAutoClick(Sender: TObject);
    procedure btnbreakClick(Sender: TObject);
  protected
    function ComboIdxToIndState(AIdx: Integer): Tz2mIndState;
  private
    { Private declarations }
    m_aIndRows: array[0..15] of TIndRow;
  public
    { Public declarations }
    FRd         : THANDLE;
  end;

var
  fmIndicators: TfmIndicators;

implementation

{$R *.dfm}

uses
  uAppUtils;

procedure TfmIndicators.btnRedAutoClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_Auto, z2mi_NoChange, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnRedOffClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_Disable, z2mi_NoChange, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnRedOnClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_Enable, z2mi_NoChange, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnSoundAutoClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_NoChange, z2mi_Auto);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnSoundOffClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_NoChange, z2mi_Disable);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnSoundOnClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_NoChange, z2mi_Enable);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

function TfmIndicators.ComboIdxToIndState(AIdx: Integer): Tz2mIndState;
begin
  case AIdx of
    0: Result := z2mi_Enable;
    1: Result := z2mi_Disable;
    2: Result := z2mi_Auto;
    else Result := z2mi_NoChange;
  end;
end;

procedure TfmIndicators.btnbreakClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mBreakIndicatorFlash(FRd);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnGreenAutoClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_Auto, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnGreenOffClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_Disable, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnGreenOnClick(Sender: TObject);
var
  nRet: Integer;
begin
  nRet := z2mSetIndicatorState(FRd, z2mi_NoChange, z2mi_Enable, z2mi_NoChange);
  if nRet <> Z2M_SUCCESS then
    MsgBoxZ2mErr(Handle, nRet);
end;

procedure TfmIndicators.btnPlayClick(Sender: TObject);
var
  i, nRet: Integer;
  a: array of Tz2mIndFlash;
  ft: Single;
begin
  for i := 0 to Length(m_aIndRows) - 1 do
  begin
    with m_aIndRows[i] do
    begin
      if chkUse.Checked then
      begin
        SetLength(a, Length(a)+1);
        with a[High(a)] do
        begin
          nRed := ComboIdxToIndState(cbRed.ItemIndex);
          nGreen := ComboIdxToIndState(cbGreen.ItemIndex);
          nSound := ComboIdxToIndState(cbSound.ItemIndex);
          if not TryStrToFloat(edtTime.Text, ft) then exit;
          nTime := Round(ft * 1000);
        end;
      end;
    end;
  end;
  if Length(a)>0 then
  begin
    nRet := z2mAddIndicatorFlash(FRd, @a[0], Length(a), True);
    if nRet <> Z2M_SUCCESS then
      MsgBoxZ2mErr(Handle, nRet);
  end;
end;

procedure TfmIndicators.FormCreate(Sender: TObject);
var
  i, nTop: Integer;
begin
  FRd := 0;
  with m_aIndRows[0] do
  begin
    chkUse:= chkUse1;
    cbRed:= cbRed1;
    cbGreen:= cbGreen1;
    cbSound:= cbSound1;
    edtTime:= edtTime1;
  end;
  nTop := chkUse1.Top+chkUse1.Height+2;
  for i := 1 to Length(m_aIndRows) - 1 do
  begin
    with m_aIndRows[i] do
    begin
      chkUse:= TCheckBox.Create(Self);
      with chkUse do
      begin
        Parent := chkUse1.Parent;
        Left := chkUse1.Left;
        Width := chkUse1.Width;
        Top := nTop;
        Height := chkUse1.Height;
        Caption := IntToStr(i+1);
      end;
      cbRed:= TComboBox.Create(Self);
      with cbRed do
      begin
        Parent := cbRed1.Parent;
        Left := cbRed1.Left;
        Width := cbRed1.Width;
        Top := nTop;
        Height := cbRed1.Height;
        Items.AddStrings(cbRed1.Items);
        ItemIndex := cbRed1.ItemIndex;
        Style := cbRed1.Style;
      end;
      cbGreen:= TComboBox.Create(Self);
      with cbGreen do
      begin
        Parent := cbGreen1.Parent;
        Left := cbGreen1.Left;
        Width := cbGreen1.Width;
        Top := nTop;
        Height := cbGreen1.Height;
        Items.AddStrings(cbGreen1.Items);
        ItemIndex := cbGreen1.ItemIndex;
        Style := cbRed1.Style;
      end;
      cbSound:= TComboBox.Create(Self);
      with cbSound do
      begin
        Parent := cbSound1.Parent;
        Left := cbSound1.Left;
        Width := cbSound1.Width;
        Top := nTop;
        Height := cbSound1.Height;
        Items.AddStrings(cbSound1.Items);
        ItemIndex := cbSound1.ItemIndex;
        Style := cbRed1.Style;
      end;
      edtTime:= TJvSpinEdit.Create(Self);
      with edtTime do
      begin
        Parent := edtTime1.Parent;
        Left := edtTime1.Left;
        Width := edtTime1.Width;
        Top := nTop;
        Height := edtTime1.Height;
        ValueType := edtTime1.ValueType;
        Decimal := edtTime1.Decimal;
        MaxValue := edtTime1.MaxValue;
        Increment := edtTime1.Increment;
        ButtonKind := edtTime1.ButtonKind;
        Value := edtTime1.Value;
      end;
      Inc(nTop, chkUse1.Height+2);
    end;
  end;
end;

procedure TfmIndicators.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to Length(m_aIndRows) - 1 do
  begin
    with m_aIndRows[i] do
    begin
      chkUse.Free;
      cbRed.Free;
      cbGreen.Free;
      cbSound.Free;
      edtTime.Free;
    end;
  end;
end;

end.
