unit uRdTimeDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, z2m, ExtCtrls;

type
  TfmRdTime = class(TForm)
    btnClose: TButton;
    GroupBox6: TGroupBox;
    DateTimePicker1: TDateTimePicker;
    btnSetTimeNow: TButton;
    labRdTime: TLabel;
    DateTimePicker2: TDateTimePicker;
    btnSyncTime: TButton;
    Timer1: TTimer;
    procedure btnSetTimeNowClick(Sender: TObject);
    procedure btnSyncTimeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    FRd: THandle;

    procedure UpdateRdTime();
  end;

var
  fmRdTime: TfmRdTime;

implementation

{$R *.dfm}

uses
  uAppUtils, DateUtils;

procedure TfmRdTime.btnSetTimeNowClick(Sender: TObject);
var
  rTime: Tz2mTime;
  nRet: Tz2mStatus;
  nY, nM, nD, nH, nMM, nS, nMs: Word;
begin
  DecodeDate(DateTimePicker1.Date, nY, nM, nD);
  DecodeTime(DateTimePicker2.Time, nH, nMM, nS, nMs);
  with rTime do
  begin
    nSecond := nS;
    nMinute := nMM;
    nHour := nH;
    nDay := nD;
    nMonth := nM;
    nYear := nY;
  end;
  nRet := z2mSetReaderTime(FRd, @rTime);
  if nRet <> Z2M_SUCCESS then
  begin
    MsgBoxZ2mErr(Handle, nRet);
    exit;
  end;
  labRdTime.Caption := format('%.2d.%.2d.%.4d %.2d:%.2d:%.2d', [nD, nM, nY, nH, nMM, nS]);
end;

procedure TfmRdTime.btnSyncTimeClick(Sender: TObject);
var
  rTime: Tz2mTime;
  nRet: Tz2mStatus;
  nY, nM, nD, nH, nMM, nS, nMs: Word;
begin
  DecodeDatetime(Now, nY, nM, nD, nH, nMM, nS, nMs);
  with rTime do
  begin
    nSecond := nS;
    nMinute := nMM;
    nHour := nH;
    nDay := nD;
    nMonth := nM;
    nYear := nY;
  end;
  nRet := z2mSetReaderTime(FRd, @rTime);
  if nRet <> Z2M_SUCCESS then
  begin
    MsgBoxZ2mErr(Handle, nRet);
    exit;
  end;
  labRdTime.Caption := format('%.2d.%.2d.%.4d %.2d:%.2d:%.2d', [nD, nM, nY, nH, nMM, nS]);
end;

procedure TfmRdTime.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := False;
end;

procedure TfmRdTime.FormShow(Sender: TObject);
begin
  UpdateRdTime();
  Timer1.Enabled := True;
end;

procedure TfmRdTime.Timer1Timer(Sender: TObject);
begin
  UpdateRdTime();
end;

procedure TfmRdTime.UpdateRdTime();
var
  rTime: Tz2mTime;
  nRet: Tz2mStatus;
begin
  nRet := z2mGetReaderTime(FRd, @rTime);
  if nRet <> Z2M_SUCCESS then exit;
//  begin
//    MsgBoxZ2mErr(Handle, nRet);
//    exit;
//  end;
  labRdTime.Caption := format('%.2d.%.2d.%.4d %.2d:%.2d:%.2d', [
      rTime.nDay, rTime.nMonth, rTime.nYear,
      rTime.nHour, rTime.nMinute, rTime.nSecond]);
end;

end.
